﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

delegate void LogDelegate(string s);

class X {
	public event LogDelegate Log;

	public void Do() {
		Log("begin");
		// ...
		Log("end");
	}
}

class Program {
	static void Main(string[] args) {
		LogDelegate log = null;

		// System.NullReferenceException
		// log("Main");

		log += f;
		log("Main");

		log -= f;
		// System.NullReferenceException
		// log("Main");

		//
		//
		//

		X x = new X();

		// Compile Error: The event 'X.Log' can only appear on the left hand side of += or -= (except when used from within the type 'X')
		// x.Log();

		// System.NullReferenceException in .Do()
		// x.Do();

		x.Log += f;
		x.Do();

		x.Log += g;
		x.Do();

		x.Log -= f;
		x.Do();

		x.Log -= g;
		// System.NullReferenceException in .Do()
		// x.Do();

		//
		//
		//

		Y y = new Y();

		// Now OK -> NO System.NullReferenceException in .Do()
		y.Do();

		y.Log += f;
		y.Do();

		y.Log += g;
		y.Do();

		y.Log -= f;
		y.Do();

		y.Log -= g;
		// Now OK -> NO System.NullReferenceException in .Do()
		y.Do();
	}

	static void f(string s) {
		Console.WriteLine("f: {0}", s);
	}

	static void g(string s) {
		Console.WriteLine("g: {0}", s);
	}

	class Y {
		public event LogDelegate Log;

		public void Do() {
			if (Log != null) Log("begin");
			// ...
			Log?.Invoke("end");
		}
	}
}

